{
    "$graph": [
        {
            "class": "Workflow",
            "label": "FragPipe:  Convert - Identify - PeptideProphet",
            "doc": "The first step of the workflow consists of converting the raw mass spectrometry data to the mzML format using msconvert, followed by the database search using MSFragger, and the peptide validation using PeptideProphet.\n\n#End-user license agreement (EULA)\n\nA central tool in this workflow is MSFragger which can only be used for academic research, non-commercial or educational purposes.  To run this workflow you must accept the EULA below.\n\n```\n#7143 - MSFragger - Academic and Research Education Use License\n\nThis license includes a digital file, available for download after the license agreement has been executed and approved (if necessary) which includes the University of Michigan PROGRAM.\n\n\nNOTICE: MSFragger utilizes the MSFTBX library to read mzXML and mzML files. The MSFTBX uses third-party software that is subject to open source and/or third-party license terms. These terms are attached in the file LICENSE-3RD-PARTY.txt. By accepting the terms and conditions of this Agreement, LICENSEE will also be subject to those terms and conditions.\n\n\nPROGRAM: MSFragger UM # 7143 - Philosopher Pipeline Distribution Permissions - Cancer Genomics Cloud\n\n\nThis Agreement is made by and between The Regents of The University of Michigan, a constitutional corporation of the state of Michigan (hereinafter \"MICHIGAN\") and LICENSEE.\n\n\nBACKGROUND\n\n1. Members of the University of Michigan\u2019s Medical School Departments of Pathology and Computational Medicine and Bioinformatics have developed a proprietary software application and related documentation for peptide identification referred to as \u201cMSFragger\u201d, for use by trained individuals in bioinformatics and proteomics research (hereinafter referred to as \"PROGRAM\"); and\n\n2. LICENSEE desires to obtain, and MICHIGAN, consistent with its mission of education and research, desires to grant, a license to use the PROGRAM subject to the terms and conditions set forth below; and\n\nThe parties therefore agree as follows:\n\n\nI. LICENSE\n\nMICHIGAN hereby grants to LICENSEE a non-exclusive, non-transferable right to use the PROGRAM solely for academic research, non-commercial or educational purposes within the LICENSEE\u2019s department and subject to the terms and conditions of this Agreement. Commercial use of any kind of the PROGRAM is strictly prohibited. This license is solely for deployment of the PROGRAM in conjunction with the Cancer Genomics Cloud project. No other license rights are granted.\n\n\nII. LIMITATION OF LICENSE AND RESTRICTIONS\n\nA. LICENSEE shall not use, print, copy, translate, reverse engineer, decompile, disassemble, modify, create derivative works of or publicly display the PROGRAM, in whole or in part, unless expressly authorized by this Agreement.\n\nB. LICENSEE agrees that it shall use the PROGRAM only for LICENSEE'S sole and exclusive use, and shall not disclose, sell, license, or otherwise distribute the PROGRAM, in whole or in part, to any third party without the prior written consent of MICHIGAN. LICENSEE shall not assign this Agreement, and any attempt by LICENSEE to assign it shall be void from the beginning. LICENSEE agrees to secure and protect the PROGRAM and any copies of the PROGRAM in a manner consistent with the maintenance of MICHIGAN'S rights in the PROGRAM and to take appropriate action by instruction or agreement with its employees who are permitted access to the PROGRAM in order to satisfy LICENSEE'S obligations under this Agreement.\n\nC. LICENSEE may copy the PROGRAM for the purpose of using the PROGRAM on other devices and for archival purposes.\n\nD. Such license shall be only for its intended use and in accordance with applicable Food and Drug Administration (FDA) regulations for pre-clinical and clinical research, including, but not limited to, applicable investigational device exemption (IDE) regulations, institutional review board (IRB) approval, required protocols and monitoring of the study, required records and reports, and applicable protection of human subjects regulations.\n\nE. LICENSEE agrees to acknowledge MICHIGAN in scientific publications resulting (in part) of the use of the PROGRAM, by making reference to the publication of the PROGRAM when it becomes available in the scientific literature. Copyright notice should be as follows, \u201cMSFragger \u00a9 2016 The Regents of the University of Michigan.\u201d\n\n\nIII. CONSIDERATION\n\nA no-cost option for the license rights granted in this Agreement.\n\n\nIV. TITLE AND OWNERSHIP\n\nA. No ownership rights of MICHIGAN in the PROGRAM are conferred upon LICENSEE by this Agreement.\n\nB. LICENSEE acknowledges MICHIGAN'S proprietary rights in the PROGRAM and agrees to reproduce all copyright notices supplied by MICHIGAN on all copies of the PROGRAM.\n\nC. LICENSEE agrees this license is explicitly for academic research applications only and that it cannot be used for commercial purposes of any kind. LICENSEE further acknowledges that any use in a commercial setting will be subject to prosecution to the fullest extent available under the law and remedies may include full recovery of legal, operational, economic and other losses which the LICENSEE will be directly liable for.\n\n\nV. DISCLAIMER OF WARRANTY AND LIMITATION OF LIABILITY\n\nA. THE PROGRAM IS PROVIDED \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. MICHIGAN DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED IN THE PROGRAM WILL MEET LICENSEE'S REQUIREMENTS OR THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. MICHIGAN shall not be liable for special, indirect, incidental, or consequential damages with respect to any claim on account of or arising from this Agreement or use of the PROGRAM, even if MICHIGAN has been or is hereafter advised of the possibility of such damages. Because some states do not allow certain exclusions or limitations on implied warranties or of liability for consequential or incidental damages, the above exclusions may not apply to LICENSEE. In no event, however, will MICHIGAN be liable to LICENSEE, under any theory of recovery, in an amount in excess of the license fee paid by LICENSEE under this Agreement.\n\nB. LICENSEE agrees that MICHIGAN has no obligation to provide to LICENSEE any maintenance, support, or update services. Should MICHIGAN provide any revised versions of the PROGRAM to LICENSEE, LICENSEE agrees that this license agreement shall apply to such revised versions.\n\n\nVI. WARRANTY OF LICENSEE\n\nLICENSEE warrants and represents that it will carefully review any documentation or instructional material provided by MICHIGAN.\n\n\nVIII. TERMINATION\n\nIf LICENSEE at any time fails to abide by the terms of this Agreement, MICHIGAN shall have the right to immediately terminate the license granted herein, require the return or destruction of all copies of the PROGRAM from LICENSEE and certification in writing as to such return or destruction, and pursue any other legal or equitable remedies available.\n\n\nVIII. MISCELLANEOUS\n\nA. This Agreement shall be construed in accordance with the laws of the state of Michigan. Should LICENSEE for any reason bring a claim, demand, or other action against MICHIGAN, its agents or employees, arising out of this Agreement or the PROGRAM licensed herein, LICENSEE agrees to bring said claim only in the Michigan Court of Claims.\n\nB. THIS AGREEMENT REPRESENTS THE COMPLETE AND EXCLUSIVE STATEMENT OF THE AGREEMENT BETWEEN MICHIGAN AND LICENSEE AND SUPERSEDES ALL PRIOR AGREEMENTS, PROPOSALS, REPRESENTATIONS AND OTHER COMMUNICATIONS, VERBAL OR WRITTEN, BETWEEN THEM WITH RESPECT TO USE OF THE PROGRAM. THIS AGREEMENT MAY BE MODIFIED ONLY WITH THE MUTUAL WRITTEN APPROVAL OF AUTHORIZED REPRESENTATIVES OF THE PARTIES.\n\nC. The terms and conditions of this Agreement shall prevail notwithstanding any different, conflicting, or additional terms or conditions which may appear in any purchase order or other document submitted by LICENSEE. LICENSEE agrees that such additional or inconsistent terms are deemed rejected by MICHIGAN.\n\nD. Unless otherwise exempt therefrom, LICENSEE agrees that it will be responsible for any sales, use or excise taxes imposed by any governmental unit in this transaction except income taxes.\n\nE. LICENSEE acknowledges that the PROGRAM is of United States origin. LICENSEE agrees to comply with all applicable international and national laws that apply to the PROGRAM, including the United States Export Administration Regulations, as well as end-user, end-use, and destination restrictions issued by the United States.\n\nF. MICHIGAN and LICENSEE agree that any xerographically or electronically reproduced copy of this fully-executed agreement shall have the same legal force and effect as any copy bearing original signatures of the parties.\n\nG. MSFragger utilizes the MSFTBX library to read mzXML and mzML files. The MSFTBX uses third-party software that is subject to open source and/or third-party license terms. These terms are attached in the file LICENSE-3RD-PARTY.txt. By accepting the terms and conditions of this Agreement, LICENSEE will also be subject to those terms and conditions\n```",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/database_name",
                    "label": "database file (fas)",
                    "doc": "Path to the protein database file in FASTA format.",
                    "type": "File",
                    "https://sevenbridges.comfileTypes": "FAS",
                    "https://sevenbridges.comx": 230,
                    "https://sevenbridges.comy": 64
                },
                {
                    "id": "#main/raw_files",
                    "label": "RAW files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "https://sevenbridges.comfileTypes": "RAW",
                    "https://sevenbridges.comx": 31,
                    "https://sevenbridges.comy": 64
                },
                {
                    "id": "#main/decoy",
                    "doc": "semi-supervised mode, protein name prefix to identify decoy entries (default \"rev_\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/combine",
                    "doc": "combine the results from PeptideProphet into a single result file",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/accmass",
                    "doc": "use accurate mass model binning",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/decoyprobs",
                    "doc": "compute possible non-zero probabilities for decoy entries on the last iteration",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/expectscore",
                    "doc": "use expectation value as the only contributor to the f-value for modeling",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/nonparam",
                    "doc": "use semi-parametric modeling, must be used in conjunction with --decoy option",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/ppm",
                    "doc": "use ppm mass error instead of Daltons for mass modeling",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/EULA",
                    "label": "Accept End Level User Agreement",
                    "type": "boolean",
                    "https://sevenbridges.comx": 36.55677032470703,
                    "https://sevenbridges.comy": 223.6128692626953
                },
                {
                    "id": "#main/write_calibrated_mgf",
                    "doc": "Write calibrated MS2 scan to a MGF file (0 for No, 1 for Yes).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/variable_mod_05",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_X_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_Z_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_U_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_O_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_J_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_B_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_W_tryptophan",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/add_C_cysteine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/deisotope",
                    "doc": "Perform deisotoping or not.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/max_fragment_charge",
                    "doc": "Maximum charge state for theoretical fragments to match (1-4).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/digest_max_length",
                    "doc": "Maximum length of peptides to be generated during in-silico digestion.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/digest_min_length",
                    "doc": "Minimum length of peptides to be generated during in-silico digestion.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_charge",
                    "doc": "Assumed range of potential precursor charge states. Only relevant when override_charge is set to 1.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/output_report_topN",
                    "doc": "Reports top N PSMs per input spectrum.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/variable_mod_04",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/variable_mod_03",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/variable_mod_02",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/variable_mod_01",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/allowed_missed_cleavage",
                    "doc": "Allowed number of missed cleavages per peptide. Maximum value is 5.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/num_enzyme_termini",
                    "doc": "0 for non-enzymatic, 1 for semi-enzymatic, and 2 for fully-enzymatic.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/search_enzyme_cutafter",
                    "doc": "Residues after which the enzyme cuts.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/search_enzyme_name",
                    "doc": "Name of enzyme to be written to the pepXML file.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/isotope_error",
                    "doc": "Also search for MS/MS events triggered on specified isotopic peaks.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/decoy_prefix",
                    "doc": "Prefix added to the decoy protein ID.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/calibrate_mass",
                    "doc": "Perform mass calibration (0 for OFF, 1 for ON, 2 for ON and find optimal parameters).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/fragment_mass_units",
                    "doc": "Fragment mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/fragment_mass_tolerance",
                    "doc": "Fragment mass tolerance (window is +/- this value).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_true_units",
                    "doc": "True precursor mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_true_tolerance",
                    "doc": "True precursor mass tolerance (window is +/- this value).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_mass_units",
                    "doc": "Precursor mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_mass_upper",
                    "doc": "Upper bound of the precursor mass window.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                },
                {
                    "id": "#main/precursor_mass_lower",
                    "doc": "Lower bound of the precursor mass window.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://sevenbridges.comexposed": true
                }
            ],
            "steps": [
                {
                    "id": "#main/peptide_prophet",
                    "label": "Philosopher PeptideProphet",
                    "in": [
                        {
                            "id": "#main/peptide_prophet/accmass",
                            "default": true,
                            "source": "#main/accmass"
                        },
                        {
                            "id": "#main/peptide_prophet/combine",
                            "default": true,
                            "source": "#main/combine"
                        },
                        {
                            "id": "#main/peptide_prophet/--database",
                            "source": "#main/database_name"
                        },
                        {
                            "id": "#main/peptide_prophet/decoy",
                            "default": "rev_",
                            "source": "#main/decoy"
                        },
                        {
                            "id": "#main/peptide_prophet/decoyprobs",
                            "default": true,
                            "source": "#main/decoyprobs"
                        },
                        {
                            "id": "#main/peptide_prophet/expectscore",
                            "default": true,
                            "source": "#main/expectscore"
                        },
                        {
                            "id": "#main/peptide_prophet/nonparam",
                            "default": true,
                            "source": "#main/nonparam"
                        },
                        {
                            "id": "#main/peptide_prophet/ppm",
                            "default": true,
                            "source": "#main/ppm"
                        },
                        {
                            "id": "#main/peptide_prophet/pepXML",
                            "source": [
                                "#main/msfragger/pepxml"
                            ]
                        },
                        {
                            "id": "#main/peptide_prophet/mzML",
                            "source": [
                                "#main/msconvert/mzML"
                            ]
                        },
                        {
                            "id": "#main/peptide_prophet/workspace_in",
                            "source": "#main/database/workspace"
                        }
                    ],
                    "run": "#peptide_prophet.cwl",
                    "out": [
                        {
                            "id": "#main/peptide_prophet/peptide_prophet_log"
                        },
                        {
                            "id": "#main/peptide_prophet/output_xml"
                        },
                        {
                            "id": "#main/peptide_prophet/peptide_prophet_folder_archive"
                        },
                        {
                            "id": "#main/peptide_prophet/peptide_archive_with_mzml"
                        }
                    ],
                    "https://sevenbridges.comx": 749,
                    "https://sevenbridges.comy": 56
                },
                {
                    "id": "#main/workspace",
                    "label": "Philosopher Workspace",
                    "in": [
                        {
                            "id": "#main/workspace/init",
                            "default": true
                        },
                        {
                            "id": "#main/workspace/nocheck",
                            "default": false
                        },
                        {
                            "id": "#main/workspace/meta_data_files",
                            "source": [
                                "#main/raw_files"
                            ]
                        }
                    ],
                    "run": "#workspace.cwl",
                    "out": [
                        {
                            "id": "#main/workspace/workspace"
                        }
                    ],
                    "https://sevenbridges.comx": 243.94737243652344,
                    "https://sevenbridges.comy": -122.02381896972656
                },
                {
                    "id": "#main/msconvert",
                    "label": "msconvert",
                    "in": [
                        {
                            "id": "#main/msconvert/raw_files",
                            "source": "#main/raw_files"
                        }
                    ],
                    "scatter": [
                        "#main/msconvert/raw_files"
                    ],
                    "run": "#msconvert.cwl",
                    "out": [
                        {
                            "id": "#main/msconvert/std_out"
                        },
                        {
                            "id": "#main/msconvert/mzML"
                        }
                    ],
                    "https://sevenbridges.comx": 253.42431640625,
                    "https://sevenbridges.comy": 336.7692565917969
                },
                {
                    "id": "#main/database",
                    "label": "Philosopher Database",
                    "in": [
                        {
                            "id": "#main/database/annotate",
                            "source": "#main/database_name"
                        },
                        {
                            "id": "#main/database/workspace_in",
                            "source": "#main/workspace/workspace"
                        }
                    ],
                    "run": "#database.cwl",
                    "out": [
                        {
                            "id": "#main/database/output"
                        },
                        {
                            "id": "#main/database/workspace"
                        }
                    ],
                    "https://sevenbridges.comx": 478,
                    "https://sevenbridges.comy": -133
                },
                {
                    "id": "#main/msfragger",
                    "label": "MSFragger",
                    "in": [
                        {
                            "id": "#main/msfragger/database_name",
                            "source": "#main/database_name"
                        },
                        {
                            "id": "#main/msfragger/precursor_mass_lower",
                            "default": -20,
                            "source": "#main/precursor_mass_lower"
                        },
                        {
                            "id": "#main/msfragger/precursor_mass_upper",
                            "default": 20,
                            "source": "#main/precursor_mass_upper"
                        },
                        {
                            "id": "#main/msfragger/precursor_mass_units",
                            "default": 1,
                            "source": "#main/precursor_mass_units"
                        },
                        {
                            "id": "#main/msfragger/precursor_true_tolerance",
                            "default": 20,
                            "source": "#main/precursor_true_tolerance"
                        },
                        {
                            "id": "#main/msfragger/precursor_true_units",
                            "default": 1,
                            "source": "#main/precursor_true_units"
                        },
                        {
                            "id": "#main/msfragger/fragment_mass_tolerance",
                            "default": 20,
                            "source": "#main/fragment_mass_tolerance"
                        },
                        {
                            "id": "#main/msfragger/fragment_mass_units",
                            "default": 1,
                            "source": "#main/fragment_mass_units"
                        },
                        {
                            "id": "#main/msfragger/calibrate_mass",
                            "default": 0,
                            "source": "#main/calibrate_mass"
                        },
                        {
                            "id": "#main/msfragger/write_calibrated_mgf",
                            "source": "#main/write_calibrated_mgf"
                        },
                        {
                            "id": "#main/msfragger/decoy_prefix",
                            "default": "rev_",
                            "source": "#main/decoy_prefix"
                        },
                        {
                            "id": "#main/msfragger/isotope_error",
                            "default": "-1/0/1/2/3",
                            "source": "#main/isotope_error"
                        },
                        {
                            "id": "#main/msfragger/precursor_mass_mode",
                            "default": "selected"
                        },
                        {
                            "id": "#main/msfragger/localize_delta_mass",
                            "default": "0"
                        },
                        {
                            "id": "#main/msfragger/fragment_ion_series",
                            "default": "b,y"
                        },
                        {
                            "id": "#main/msfragger/search_enzyme_name",
                            "default": "stricttrypsin",
                            "source": "#main/search_enzyme_name"
                        },
                        {
                            "id": "#main/msfragger/search_enzyme_cutafter",
                            "default": "KR",
                            "source": "#main/search_enzyme_cutafter"
                        },
                        {
                            "id": "#main/msfragger/num_enzyme_termini",
                            "default": 2,
                            "source": "#main/num_enzyme_termini"
                        },
                        {
                            "id": "#main/msfragger/allowed_missed_cleavage",
                            "default": 2,
                            "source": "#main/allowed_missed_cleavage"
                        },
                        {
                            "id": "#main/msfragger/clip_nTerm_M",
                            "default": 1
                        },
                        {
                            "id": "#main/msfragger/variable_mod_01",
                            "default": "15.99490_M_3",
                            "source": "#main/variable_mod_01"
                        },
                        {
                            "id": "#main/msfragger/variable_mod_02",
                            "default": "42.01060_[^_1",
                            "source": "#main/variable_mod_02"
                        },
                        {
                            "id": "#main/msfragger/variable_mod_03",
                            "default": "229.162932_n^_1",
                            "source": "#main/variable_mod_03"
                        },
                        {
                            "id": "#main/msfragger/variable_mod_04",
                            "default": "229.162932_S_1",
                            "source": "#main/variable_mod_04"
                        },
                        {
                            "id": "#main/msfragger/variable_mod_05",
                            "source": "#main/variable_mod_05"
                        },
                        {
                            "id": "#main/msfragger/allow_multiple_variable_mods_on_residue",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/max_variable_mods_per_peptide",
                            "default": 3
                        },
                        {
                            "id": "#main/msfragger/max_variable_mods_combinations",
                            "default": 5000
                        },
                        {
                            "id": "#main/msfragger/output_file_extension",
                            "default": "pepXML"
                        },
                        {
                            "id": "#main/msfragger/output_format",
                            "default": "pepXML"
                        },
                        {
                            "id": "#main/msfragger/output_report_topN",
                            "default": 1,
                            "source": "#main/output_report_topN"
                        },
                        {
                            "id": "#main/msfragger/output_max_expect",
                            "default": 50
                        },
                        {
                            "id": "#main/msfragger/report_alternative_proteins",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/precursor_charge",
                            "default": "1_6",
                            "source": "#main/precursor_charge"
                        },
                        {
                            "id": "#main/msfragger/override_charge",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/digest_min_length",
                            "default": 7,
                            "source": "#main/digest_min_length"
                        },
                        {
                            "id": "#main/msfragger/digest_max_length",
                            "default": 50,
                            "source": "#main/digest_max_length"
                        },
                        {
                            "id": "#main/msfragger/digest_mass_range",
                            "default": "500.0_5000.0"
                        },
                        {
                            "id": "#main/msfragger/max_fragment_charge",
                            "default": 2,
                            "source": "#main/max_fragment_charge"
                        },
                        {
                            "id": "#main/msfragger/track_zero_topN",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/zero_bin_accept_expect",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/zero_bin_mult_expect",
                            "default": 1
                        },
                        {
                            "id": "#main/msfragger/add_topN_complementary",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/minimum_peaks",
                            "default": 15
                        },
                        {
                            "id": "#main/msfragger/use_topN_peaks",
                            "default": 300
                        },
                        {
                            "id": "#main/msfragger/deisotope",
                            "default": 1,
                            "source": "#main/deisotope"
                        },
                        {
                            "id": "#main/msfragger/min_fragments_modelling",
                            "default": 3
                        },
                        {
                            "id": "#main/msfragger/min_matched_fragments",
                            "default": 4
                        },
                        {
                            "id": "#main/msfragger/minimum_ratio",
                            "default": 0.01
                        },
                        {
                            "id": "#main/msfragger/clear_mz_range",
                            "default": "125.5_131.5"
                        },
                        {
                            "id": "#main/msfragger/remove_precursor_peak",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/add_C_cysteine",
                            "default": 57.021464,
                            "source": "#main/add_C_cysteine"
                        },
                        {
                            "id": "#main/msfragger/add_K_lysine",
                            "default": 229.162932
                        },
                        {
                            "id": "#main/msfragger/add_W_tryptophan",
                            "source": "#main/add_W_tryptophan"
                        },
                        {
                            "id": "#main/msfragger/add_B_user_amino_acid",
                            "source": "#main/add_B_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/add_J_user_amino_acid",
                            "source": "#main/add_J_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/add_O_user_amino_acid",
                            "source": "#main/add_O_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/add_U_user_amino_acid",
                            "source": "#main/add_U_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/add_X_user_amino_acid",
                            "source": "#main/add_X_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/add_Z_user_amino_acid",
                            "source": "#main/add_Z_user_amino_acid"
                        },
                        {
                            "id": "#main/msfragger/mzML",
                            "source": [
                                "#main/msconvert/mzML"
                            ]
                        },
                        {
                            "id": "#main/msfragger/diagnostic_intensity_filter",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/restrict_deltamass_to",
                            "default": "all"
                        },
                        {
                            "id": "#main/msfragger/labile_search_mode",
                            "default": "off"
                        },
                        {
                            "id": "#main/msfragger/mass_diff_to_variable_mod",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/intensity_transform",
                            "default": 0
                        },
                        {
                            "id": "#main/msfragger/EULA",
                            "source": "#main/EULA"
                        }
                    ],
                    "run": "#msfragger.cwl",
                    "out": [
                        {
                            "id": "#main/msfragger/standard_out"
                        },
                        {
                            "id": "#main/msfragger/pepxml"
                        },
                        {
                            "id": "#main/msfragger/mgf"
                        }
                    ],
                    "https://sevenbridges.comx": 493.7692565917969,
                    "https://sevenbridges.comy": 65.94041442871094
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": "1"
                },
                {
                    "class": "https://sevenbridges.comAWSInstanceType",
                    "value": "c5.4xlarge;ebs-gp2;200"
                }
            ],
            "id": "#main",
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcategories": [
                "Proteomics"
            ],
            "https://sevenbridges.comcontent_hash": "aa6f3d0850b60a8fba6d5546b97a566ad7c00506d37a528ef8dee83261a63b1f8",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1618968733,
            "https://sevenbridges.comid": "david.roberson/build-fragpipe-proteomics-pipeline-tutorial/fragpipe-convert-identify-peptideprophet/4",
            "https://sevenbridges.comimage_url": "https://cgc.sbgenomics.com/ns/brood/images/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/fragpipe-convert-identify-peptideprophet/4.png",
            "https://sevenbridges.comlatestRevision": 4,
            "https://sevenbridges.comlicense": "EULA for MSFragger",
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1618985740,
            "https://sevenbridges.comoriginal_source": "https://cgc-api.sbgenomics.com/v2/apps/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/fragpipe-convert-identify-peptideprophet/4/raw/",
            "https://sevenbridges.comproject": "david.roberson/build-fragpipe-proteomics-pipeline-tutorial",
            "https://sevenbridges.comprojectName": "BUILD: FragPipe Proteomics Pipeline Tutorial",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 4,
            "https://sevenbridges.comrevisionNotes": "fixed deisotope",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618968733,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/fragpipe-proteomics-pipeline-tutorial.git\nfile: \ncommit: (uncommitted file)"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618978447,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/fragpipe-proteomics-pipeline-tutorial.git\nfile: FragPipe-Convert-Identify-PeptideProphet/fragpipe-convert-identify-peptideprophet.cwl\ncommit: f6161f0"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618979582,
                    "https://sevenbridges.comrevision": 2,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618983523,
                    "https://sevenbridges.comrevision": 3,
                    "https://sevenbridges.comrevisionNotes": "added many defaults to msfraggger as they were before"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618985740,
                    "https://sevenbridges.comrevision": 4,
                    "https://sevenbridges.comrevisionNotes": "fixed deisotope"
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comtoolkit": "FragPipe",
            "https://sevenbridges.comtoolkitVersion": "v15.0",
            "https://sevenbridges.comvalidationErrors": [],
            "outputs": [
                {
                    "id": "#main/peptide_prophet_folder_archive",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": [
                        "#main/peptide_prophet/peptide_prophet_folder_archive"
                    ],
                    "https://sevenbridges.comx": 913,
                    "https://sevenbridges.comy": -84
                },
                {
                    "id": "#main/peptide_archive_with_mzml",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": [
                        "#main/peptide_prophet/peptide_archive_with_mzml"
                    ],
                    "https://sevenbridges.comx": 958,
                    "https://sevenbridges.comy": 176
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Philosopher Database",
            "doc": "```\nUsage:\n  philosopher database [flags]\n\nFlags:\n      --add string        add custom sequences (UniProt FASTA format only)\n      --annotate string   process a ready-to-use database\n      --contam            add common contaminants\n      --custom string     use a pre-formatted custom database\n      --enzyme string     enzyme for digestion (trypsin, lys_c, lys_n, glu_c, chymotrypsin) (default \"trypsin\")\n  -h, --help              help for database\n      --id string         UniProt proteome ID\n      --isoform           add isoform sequences\n      --nodecoys          don't add decoys to the database\n```",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 0,
                    "ramMin": 2000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "prvst/philosopher:3.2.3"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "philosopher_database.sh",
                            "writable": false,
                            "entry": "tar -xvzf $(inputs.workspace_in.path) -C ./\n\ncd $(inputs.workspace_in.metadata[\"Plex or dataset name\"])\n\nphilosopher database $@\n\ncd ../\n\ntar -cvzf $(inputs.workspace_in.metadata[\"Plex or dataset name\"]).tar.gz $(inputs.workspace_in.metadata[\"Plex or dataset name\"])"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file)) {\n        file['metadata'] = {}\n    }\n    for (var key in metadata) {\n        file['metadata'][key] = metadata[key];\n    }\n    return file\n};\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!o2) {\n        return o1;\n    };\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n        for (var key in commonMetadata) {\n            if (!(key in example)) {\n                delete commonMetadata[key]\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n        if (o1.secondaryFiles) {\n            o1.secondaryFiles = inheritMetadata(o1.secondaryFiles, o2)\n        }\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n            if (o1[i].secondaryFiles) {\n                o1[i].secondaryFiles = inheritMetadata(o1[i].secondaryFiles, o2)\n            }\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/add",
                    "doc": "add custom sequences (UniProt FASTA format only)",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": null,
                    "inputBinding": {
                        "prefix": "--add",
                        "position": 0,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/annotate",
                    "doc": "process a ready-to-use database",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--annotate",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/contam",
                    "doc": "add common contaminants",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--contam",
                        "position": 3,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/custom",
                    "doc": "use a pre-formatted custom database",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--custom",
                        "position": 0,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/enzyme",
                    "doc": "enzyme for digestion (trypsin, lys_c, lys_n, glu_c, chymotrypsin) (default \"trypsin\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "trypsin",
                    "inputBinding": {
                        "prefix": "--enzyme",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/id",
                    "doc": "UniProt proteome ID",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--id",
                        "position": 6,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/isoform",
                    "doc": "add isoform sequences",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--isoform",
                        "position": 7,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/nodecoys",
                    "doc": "don't add decoys to the database",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--nodecoys",
                        "position": 8,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/prefix",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "rev_",
                    "inputBinding": {
                        "prefix": "--prefix",
                        "position": 9,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/reviewed",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--reviewed",
                        "position": 10,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/workspace_in",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "std.out"
                    }
                },
                {
                    "id": "#database.cwl/david.roberson/pdc-webinar-dev/database/4/workspace",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.tar.gz",
                        "outputEval": "$(inheritMetadata(self, inputs.workspace_in))"
                    }
                }
            ],
            "stdout": "std.out",
            "baseCommand": [
                "bash philosopher_database.sh"
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "*.out"
                },
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "*.sh"
                }
            ],
            "id": "#database.cwl",
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcontent_hash": "a1963dbc9c0bdb17105f27d6a56a9eb3b9d264aff95433302791a02ab0f542ab2",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1616674914,
            "https://sevenbridges.comid": "david.roberson/pdc-webinar-dev/database/4",
            "https://sevenbridges.comimage_url": null,
            "https://sevenbridges.comlatestRevision": 4,
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1616679449,
            "https://sevenbridges.comproject": "david.roberson/pdc-webinar-dev",
            "https://sevenbridges.comprojectName": "PDC Webinar Dev",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 4,
            "https://sevenbridges.comrevisionNotes": "inherit metadata",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616674914,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/shotgun_proteomics.git\nfile: tools/database/database.cwl\ncommit: 31fdf12"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616676112,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616678466,
                    "https://sevenbridges.comrevision": 2,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616679008,
                    "https://sevenbridges.comrevision": 3,
                    "https://sevenbridges.comrevisionNotes": "fixing cd"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616679449,
                    "https://sevenbridges.comrevision": 4,
                    "https://sevenbridges.comrevisionNotes": "inherit metadata"
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comvalidationErrors": []
        },
        {
            "class": "CommandLineTool",
            "label": "msconvert",
            "doc": "```\nUsage: msconvert [options] [filemasks]\nConvert mass spec data file formats.\n\nReturn value: # of failed files.\n\nOptions:\n  -f [ --filelist ] arg              : specify text file containing filenames\n  -o [ --outdir ] arg (=.)           : set output directory ('-' for stdout) \n                                     [.]\n  -c [ --config ] arg                : configuration file (optionName=value)\n  --outfile arg                      : Override the name of output file.\n  -e [ --ext ] arg                   : set extension for output files \n                                     [mzML|mzXML|mgf|txt|mz5]\n  --mzML                             : write mzML format [default]\n  --mzXML                            : write mzXML format\n  --mz5                              : write mz5 format\n  --mgf                              : write Mascot generic format\n  --text                             : write ProteoWizard internal text format\n  --ms1                              : write MS1 format\n  --cms1                             : write CMS1 format\n  --ms2                              : write MS2 format\n  --cms2                             : write CMS2 format\n  -v [ --verbose ]                   : display detailed progress information\n  --64                               : set default binary encoding to 64-bit \n                                     precision [default]\n  --32                               : set default binary encoding to 32-bit\n                                   precision [default]\n  --32                               : set default binary encoding to 32-bit \n                                     precision\n  --mz64                             : encode m/z values in 64-bit precision \n                                     [default]\n  --mz32                             : encode m/z values in 32-bit precision\n  --inten64                          : encode intensity values in 64-bit \n                                     precision\n  --inten32                          : encode intensity values in 32-bit \n                                     precision [default]\n  --noindex                          : do not write index\n  -i [ --contactInfo ] arg           : filename for contact info\n  -z [ --zlib ]                      : use zlib compression for binary data\n  --numpressLinear [=arg(=2e-09)]    : use numpress linear prediction \n                                     compression for binary mz and rt data \n                                     (relative accuracy loss will not exceed \n                                     given tolerance arg, unless set to 0)\n  --numpressLinearAbsTol [=arg(=-1)] : desired absolute tolerance for linear \n                                     numpress prediction (e.g. use 1e-4 for a \n                                     mass accuracy of 0.2 ppm at 500 m/z, \n                                     default uses -1.0 for maximal accuracy). \n                                     Note: setting this value may substantially\n                                     reduce file size, this overrides relative \n                                     accuracy tolerance.\n  --numpressPic                      : use numpress positive integer \n                                     compression for binary intensities \n                                     (absolute accuracy loss will not exceed \n                                     0.5)\n  --numpressSlof [=arg(=0.0002)]     : use numpress short logged float \n                                     compression for binary intensities \n                                     (relative accuracy loss will not exceed \n                                     given tolerance arg, unless set to 0)\n  -n [ --numpressAll ]               : same as --numpressLinear --numpressSlof \n                                     (see https://github.com/fickludd/ms-numpre\n                                     ss for more info)\n  -g [ --gzip ]                      : gzip entire output file (adds .gz to\n                                    filename)\n  --filter arg                       : add a spectrum list filter\n  --chromatogramFilter arg           : add a chromatogram list filter\n  --merge                            : create a single output file from \n                                     multiple input files by merging file-level\n                                     metadata and concatenating spectrum lists\n  --runIndexSet arg                  : for multi-run sources, select only the \n                                     specified run indices\n  --simAsSpectra                     : write selected ion monitoring as \n                                     spectra, not chromatograms\n  --srmAsSpectra                     : write selected reaction monitoring as \n                                     spectra, not chromatograms\n  --combineIonMobilitySpectra        : write all drift bins/scans in a \n                                     frame/block as one spectrum instead of \n                                     individual spectra\n  --acceptZeroLengthSpectra          : some vendor readers have an efficient \n                                     way of filtering out empty spectra, but it\n                                     takes more time to open the file\n  --ignoreUnknownInstrumentError     : if true, if an instrument cannot be \n                                     determined from a vendor file, it will not\n                                     be an error\n  --stripLocationFromSourceFiles     : if true, sourceFile elements will be \n                                     stripped of location information, so the \n                                     same file converted from different \n                                     locations will produce the same mzML\n  --stripVersionFromSoftware         : if true, software elements will be \n                                     stripped of version information, so the \n                                     same file converted with different \n                                     versions will produce the same mzML\n  --singleThreaded                   : if true, reading and writing spectra \n                                     will be done on a single thread\n  --help                             : show this message, with extra detail on \n                                     filter options\n                                  filter options\n  --help-filter arg                  : name of a single filter to get detailed \n                                     help for\n\nFILTER OPTIONS\nrun this command with --help to see more detail\nindex <index_value_set>\nid <id_set>\nmsLevel <mslevels>\nchargeState <charge_states>\nprecursorRecalculation \nmzRefiner input1.pepXML input2.mzid [msLevels=<1->]\n[thresholdScore=<CV_Score_Name>] [thresholdValue=<floatset>]\n[thresholdStep=<float>] [maxSteps=<count>]\nlockmassRefiner mz=<real> mzNegIons=<real (mz)> tol=<real (1.0 Daltons)>\nprecursorRefine \npeakPicking [<PickerType> [snr=<minimum signal-to-noise ratio>]\n[peakSpace=<minimum peak spacing>] [msLevel=<ms_levels>]]\nscanNumber <scan_numbers>\nscanEvent <scan_event_set>\nscanTime <scan_time_range>\nsortByScanTime \nstripIT \nmetadataFixer \ntitleMaker <format_string>\nthreshold <type> <threshold> <orientation> [<mslevels>]\nmzWindow <mzrange>\nmzPrecursors <precursor_mz_list> [mzTol=<mzTol (10 ppm)>]\n[target=<selected|isolated> (selected)] [mode=<include|exclude (include)>]\ndefaultArrayLength <peak_count_range>\nzeroSamples <mode> [<MS_levels>]\nmzPresent <mz_list> [mzTol=<tolerance> (0.5 mz)] [type=<type> (count)]\n[threshold=<threshold> (10000)] [orientation=<orientation> (most-intense)]\n[mode=<include|exclude (include)>]\nscanSumming [precursorTol=<precursor tolerance>] [scanTimeTol=<scan time\ntolerance in seconds>] [ionMobilityTol=<ion mobility tolerance>]\nthermoScanFilter <exact|contains> <include|exclude> <match string>\nMS2Denoise [<peaks_in_window> [<window_width_Da>\n[multicharge_fragment_relaxation]]]\nMS2Deisotope [hi_res [mzTol=<mzTol>]] [Poisson [minCharge=<minCharge>]\n[maxCharge=<maxCharge>]]\nETDFilter [<removePrecursor> [<removeChargeReduced> [<removeNeutralLoss>\n[<blanketRemoval> [<matchingTolerance> ]]]]]\ndemultiplex massError=<tolerance and units, eg 0.5Da (default 10ppm)>\nnnlsMaxIter=<int (50)> nnlsEps=<real (1e-10)> noWeighting=<bool (false)>\ndemuxBlockExtra=<real (0)> variableFill=<bool (false)> noSumNormalize=<bool\n(false)> optimization=<(none)|overlap_only> interpolateRT=<bool (true)>\nminWindowSize=<real (0.2)>\nchargeStatePredictor [overrideExistingCharge=<true|false (false)>]\n[maxMultipleCharge=<int (3)>] [minMultipleCharge=<int (2)>]\n[singleChargeFractionTIC=<real (0.9)>] [maxKnownCharge=<int (0)>]\n[makeMS2=<true|false (false)>]\nturbocharger [minCharge=<minCharge>] [maxCharge=<maxCharge>]\n[precursorsBefore=<before>] [precursorsAfter=<after>] [halfIsoWidth=<half-width\nof isolation window>] [defaultMinCharge=<defaultMinCharge>]\n[defaultMaxCharge=<defaultMaxCharge>] [useVendorPeaks=<useVendorPeaks>]\nactivation <precursor_activation_type>\nanalyzer <analyzer>\nanalyzerType <analyzer>\npolarity <polarity>\n\n\nExamples:\n\n# convert data.RAW to data.mzML\nmsconvert data.RAW\n# convert data.RAW to data.mzXML\nmsconvert data.RAW --mzXML\n\n# put output file in my_output_dir\nmsconvert data.RAW -o my_output_dir\n\n# combining options to create a smaller mzML file, much like the old ReAdW converter program\nmsconvert data.RAW --32 --zlib --filter \"peakPicking true 1-\" --filter \"zeroSamples removeExtra\"\n\n# extract scan indices 5...10 and 20...25\nmsconvert data.RAW --filter \"index [5,10] [20,25]\"\n\n# extract MS1 scans only\nmsconvert data.RAW --filter \"msLevel 1\"\n\n# extract MS2 and MS3 scans only\nmsconvert data.RAW --filter \"msLevel 2-3\"\n\n# extract MSn scans for n>1\nmsconvert data.RAW --filter \"msLevel 2-\"\n\n# apply ETD precursor mass filter\nmsconvert data.RAW --filter ETDFilter\n\n# remove non-flanking zero value samples\nmsconvert data.RAW --filter \"zeroSamples removeExtra\"\n\n# remove non-flanking zero value samples in MS2 and MS3 only\nmsconvert data.RAW --filter \"zeroSamples removeExtra 2 3\"\n\n# add missing zero value samples (with 5 flanking zeros) in MS2 and MS3 only\nmsconvert data.RAW --filter \"zeroSamples addMissing=5 2 3\"\n\n# keep only HCD spectra from a decision tree data file\nmsconvert data.RAW --filter \"activation HCD\"\n\n# keep the top 42 peaks or samples (depending on whether spectra are centroid or profile):\nmsconvert data.RAW --filter \"threshold count 42 most-intense\"\n\n# multiple filters: select scan numbers and recalculate precursors\nmsconvert data.RAW --filter \"scanNumber [500,1000]\" --filter \"precursorRecalculation\"\n\n# multiple filters: apply peak picking and then keep the bottom 100 peaks:\nmsconvert data.RAW --filter \"peakPicking true 1-\" --filter \"threshold count 100 least-intense\"\n\n# multiple filters: apply peak picking and then keep all peaks that are at least 50% of the intensity of the base peak:\nmsconvert data.RAW --filter \"peakPicking true 1-\" --filter \"threshold bpi-relative .5 most-intense\"\n\n# use a configuration file\nmsconvert data.RAW -c config.txt\n\n# example configuration file\nmzXML=true\nzlib=true\nfilter=\"index [3,7]\"\nfilter=\"precursorRecalculation\"\n\n\nQuestions, comments, and bug reports:\nhttps://github.com/ProteoWizard\nsupport@proteowizard.org\n\nProteoWizard release: 3.0.20066 (729ef9c41)\nBuild date: Mar  6 2020 23:32:05\n```",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 2000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "chambm/pwiz-skyline-i-agree-to-the-vendor-licenses:3.0.20066-729ef9c41"
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file)) {\n        file['metadata'] = {}\n    }\n    for (var key in metadata) {\n        file['metadata'][key] = metadata[key];\n    }\n    return file\n};\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!o2) {\n        return o1;\n    };\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n        for (var key in commonMetadata) {\n            if (!(key in example)) {\n                delete commonMetadata[key]\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n        if (o1.secondaryFiles) {\n            o1.secondaryFiles = inheritMetadata(o1.secondaryFiles, o2)\n        }\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n            if (o1[i].secondaryFiles) {\n                o1[i].secondaryFiles = inheritMetadata(o1[i].secondaryFiles, o2)\n            }\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#msconvert.cwl/david.roberson/pdc-webinar-dev/msconvert/1/raw_files",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "shellQuote": false
                    },
                    "https://sevenbridges.comfileTypes": "RAW"
                }
            ],
            "outputs": [
                {
                    "id": "#msconvert.cwl/david.roberson/pdc-webinar-dev/msconvert/1/std_out",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "std.out",
                        "outputEval": "$(inheritMetadata(self, inputs.raw_files))"
                    }
                },
                {
                    "id": "#msconvert.cwl/david.roberson/pdc-webinar-dev/msconvert/1/mzML",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*mzML",
                        "outputEval": "$(inheritMetadata(self, inputs.raw_files))"
                    }
                }
            ],
            "stdout": "std.out",
            "baseCommand": [
                "wine msconvert --mzML --64 --mz64 --inten64 --filter \"peakPicking true 1-\""
            ],
            "id": "#msconvert.cwl",
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcontent_hash": "a7a3ea8b627ed923820f98e7fd7e3856402d96c9e9a7e0d62e4f73d44c1cc8323",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1616632419,
            "https://sevenbridges.comid": "david.roberson/pdc-webinar-dev/msconvert/1",
            "https://sevenbridges.comimage_url": null,
            "https://sevenbridges.comlatestRevision": 1,
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1616632573,
            "https://sevenbridges.comproject": "david.roberson/pdc-webinar-dev",
            "https://sevenbridges.comprojectName": "PDC Webinar Dev",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 1,
            "https://sevenbridges.comrevisionNotes": "2GB of RAM and one CPU",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616632419,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/shotgun_proteomics.git\nfile: tools/msconvert/msconvert.cwl\ncommit: 31fdf12"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616632573,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": "2GB of RAM and one CPU"
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comvalidationErrors": []
        },
        {
            "class": "CommandLineTool",
            "label": "MSFragger",
            "doc": "```\nTo perform a search either use a parameter file:\n                1) java -jar MSFragger.jar <parameter file> <list of mzML/mzXML/MGF/RAW/.d files>\n        Or specify options on the command line:\n                2) java -jar MSFragger.jar <options> <list of mzML/mzXML/MGF/RAW/.d files>\n\nTo generate default parameter files use --config flag. E.g. \"java -jar MSFragger.jar --config\"\n\n```",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 2,
                    "ramMin": 8000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "cgc-images.sbgenomics.com/david.roberson/msfragger:3.2"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.mzML)"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file)) {\n        file['metadata'] = {}\n    }\n    for (var key in metadata) {\n        file['metadata'][key] = metadata[key];\n    }\n    return file\n};\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!o2) {\n        return o1;\n    };\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n        for (var key in commonMetadata) {\n            if (!(key in example)) {\n                delete commonMetadata[key]\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n        if (o1.secondaryFiles) {\n            o1.secondaryFiles = inheritMetadata(o1.secondaryFiles, o2)\n        }\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n            if (o1[i].secondaryFiles) {\n                o1[i].secondaryFiles = inheritMetadata(o1[i].secondaryFiles, o2)\n            }\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/database_name",
                    "doc": "Path to the protein database file in FASTA format.",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--database_name",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_mass_lower",
                    "doc": "Lower bound of the precursor mass window.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": -20,
                    "inputBinding": {
                        "prefix": "--precursor_mass_lower",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_mass_upper",
                    "doc": "Upper bound of the precursor mass window.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 20,
                    "inputBinding": {
                        "prefix": "--precursor_mass_upper",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_mass_units",
                    "doc": "Precursor mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--precursor_mass_units",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_true_tolerance",
                    "doc": "True precursor mass tolerance (window is +/- this value).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 20,
                    "inputBinding": {
                        "prefix": "--precursor_true_tolerance",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_true_units",
                    "doc": "True precursor mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--precursor_true_units",
                        "position": 5,
                        "shellQuote": false
                    },
                    "https://sevenbridges.comtoolDefaultValue": "1"
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/fragment_mass_tolerance",
                    "doc": "Fragment mass tolerance (window is +/- this value).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 20,
                    "inputBinding": {
                        "prefix": "--fragment_mass_tolerance",
                        "position": 6,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/fragment_mass_units",
                    "doc": "Fragment mass tolerance units (0 for Da, 1 for ppm).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--fragment_mass_units",
                        "position": 7,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/calibrate_mass",
                    "doc": "Perform mass calibration (0 for OFF, 1 for ON, 2 for ON and find optimal parameters).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--calibrate_mass",
                        "position": 8,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/write_calibrated_mgf",
                    "doc": "Write calibrated MS2 scan to a MGF file (0 for No, 1 for Yes).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--write_calibrated_mgf",
                        "position": 9,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/decoy_prefix",
                    "doc": "Prefix added to the decoy protein ID.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "rev_",
                    "inputBinding": {
                        "prefix": "--decoy_prefix",
                        "position": 10,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/isotope_error",
                    "doc": "Also search for MS/MS events triggered on specified isotopic peaks.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "0/1/2",
                    "inputBinding": {
                        "prefix": "--isotope_error",
                        "position": 11,
                        "shellQuote": false
                    },
                    "https://sevenbridges.comtoolDefaultValue": "-1/0/1/2/3"
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/mass_offsets",
                    "doc": "Creates multiple precursor tolerance windows with specified mass offsets.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--mass_offsets",
                        "position": 12,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_mass_mode",
                    "doc": "One of isolated/selected/recalculated.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "selected",
                    "inputBinding": {
                        "prefix": "--precursor_mass_mode",
                        "position": 13,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/localize_delta_mass",
                    "doc": "Include fragment ions mass-shifted by unknown modifications (recommended for open and mass offset searches) (0 for OFF, 1 for ON).",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--localize_delta_mass",
                        "position": 14,
                        "shellQuote": false
                    },
                    "https://sevenbridges.comtoolDefaultValue": "false"
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/fragment_ion_series",
                    "doc": "Ion series used in search, specify any of a,b,c,x,y,z (comma separated).",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "b,y",
                    "inputBinding": {
                        "prefix": "--fragment_ion_series",
                        "position": 15,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/search_enzyme_name",
                    "doc": "Name of enzyme to be written to the pepXML file.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "Trypsin",
                    "inputBinding": {
                        "prefix": "--search_enzyme_name",
                        "position": 16,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/search_enzyme_cutafter",
                    "doc": "Residues after which the enzyme cuts.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "KR",
                    "inputBinding": {
                        "prefix": "--search_enzyme_cutafter",
                        "position": 17,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/search_enzyme_butnotafter",
                    "doc": "Residues that the enzyme will not cut before.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "P",
                    "inputBinding": {
                        "prefix": "--search_enzyme_butnotafter",
                        "position": 18,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/num_enzyme_termini",
                    "doc": "0 for non-enzymatic, 1 for semi-enzymatic, and 2 for fully-enzymatic.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "prefix": "--num_enzyme_termini",
                        "position": 19,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/allowed_missed_cleavage",
                    "doc": "Allowed number of missed cleavages per peptide. Maximum value is 5.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--allowed_missed_cleavage",
                        "position": 20,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/clip_nTerm_M",
                    "doc": "Specifies the trimming of a protein N-terminal methionine as a variable modification (0 or 1).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--clip_nTerm_M",
                        "position": 21,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/variable_mod_01",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "15.99490_M_3",
                    "inputBinding": {
                        "prefix": "--variable_mod_01",
                        "position": 22,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/variable_mod_02",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "42.01060_[^_1",
                    "inputBinding": {
                        "prefix": "--variable_mod_02",
                        "position": 23,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/variable_mod_03",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--variable_mod_03",
                        "position": 24,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/variable_mod_04",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--variable_mod_04",
                        "position": 25,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/variable_mod_05",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--variable_mod_05",
                        "position": 26,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/allow_multiple_variable_mods_on_residue",
                    "doc": "Allow each residue to be modified by multiple variable modifications (0 or 1).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--allow_multiple_variable_mods_on_residue",
                        "position": 27,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/max_variable_mods_per_peptide",
                    "doc": "Maximum total number of variable modifications per peptide.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 3,
                    "inputBinding": {
                        "prefix": "--max_variable_mods_per_peptide",
                        "position": 28,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/max_variable_mods_combinations",
                    "doc": "Maximum number of modified forms allowed for each peptide (up to 65534).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 5000,
                    "inputBinding": {
                        "prefix": "--max_variable_mods_combinations",
                        "position": 29,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/output_file_extension",
                    "doc": "File extension of output files.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "pepXML",
                    "inputBinding": {
                        "prefix": "--output_file_extension",
                        "position": 30,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/output_format",
                    "doc": "File format of output files (pepXML or tsv).",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "pepXML",
                    "inputBinding": {
                        "prefix": "--output_format",
                        "position": 31,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/output_report_topN",
                    "doc": "Reports top N PSMs per input spectrum.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--output_report_topN",
                        "position": 32,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/output_max_expect",
                    "doc": "Suppresses reporting of PSM if top hit has expectation value greater than this threshold.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "inputBinding": {
                        "prefix": "--output_max_expect",
                        "position": 33,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/report_alternative_proteins",
                    "doc": "Report alternative proteins for peptides that are found in multiple proteins (0 for no, 1 for yes).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--report_alternative_proteins",
                        "position": 34,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/precursor_charge",
                    "doc": "Assumed range of potential precursor charge states. Only relevant when override_charge is set to 1.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "1_4",
                    "inputBinding": {
                        "prefix": "--precursor_charge",
                        "position": 35,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/override_charge",
                    "doc": "Ignores precursor charge and uses charge state specified in precursor_charge range (0 or 1).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--override_charge",
                        "position": 36,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/digest_min_length",
                    "doc": "Minimum length of peptides to be generated during in-silico digestion.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 7,
                    "inputBinding": {
                        "prefix": "--digest_min_length",
                        "position": 37,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/digest_max_length",
                    "doc": "Maximum length of peptides to be generated during in-silico digestion.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50,
                    "inputBinding": {
                        "prefix": "--digest_max_length",
                        "position": 38,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/digest_mass_range",
                    "doc": "Mass range of peptides to be generated during in-silico digestion in Daltons.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "500.0_5000.0",
                    "inputBinding": {
                        "prefix": "--digest_mass_range",
                        "position": 39,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/max_fragment_charge",
                    "doc": "Maximum charge state for theoretical fragments to match (1-4).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "prefix": "--max_fragment_charge",
                        "position": 40,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/track_zero_topN",
                    "doc": "Track top N unmodified peptide results separately from main results internally for boosting features. Should be set to a number greater than output_report_topN if zero bin boosting is desired.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--track_zero_topN",
                        "position": 41,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/zero_bin_accept_expect",
                    "doc": "Ranks a zero-bin hit above all non-zero-bin hit if it has expectation less than this value.",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--zero_bin_accept_expect",
                        "position": 42,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/zero_bin_mult_expect",
                    "doc": "Multiplies expect value of PSMs in the zero-bin during  results ordering (set to less than 1 for boosting).",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--zero_bin_mult_expect",
                        "position": 43,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_topN_complementary",
                    "doc": "Inserts complementary ions corresponding to the top N most intense fragments in each experimental spectra.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_topN_complementary",
                        "position": 44,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/minimum_peaks",
                    "doc": "Minimum number of peaks in experimental spectrum for matching.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 15,
                    "inputBinding": {
                        "prefix": "--minimum_peaks",
                        "position": 45,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/use_topN_peaks",
                    "doc": "Pre-process experimental spectrum to only use top N peaks.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 150,
                    "inputBinding": {
                        "prefix": "--use_topN_peaks",
                        "position": 46,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/deisotope",
                    "doc": "Perform deisotoping or not.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--deisotope",
                        "position": 47,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/min_fragments_modelling",
                    "doc": "Minimum number of matched peaks in PSM for inclusion in statistical modeling.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "prefix": "--min_fragments_modelling",
                        "position": 48,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/min_matched_fragments",
                    "doc": "Minimum number of matched peaks for PSM to be reported.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 4,
                    "inputBinding": {
                        "prefix": "--min_matched_fragments",
                        "position": 49,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/minimum_ratio",
                    "doc": "Filters out all peaks in experimental spectrum less intense than this multiple of the base peak intensity.",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.01,
                    "inputBinding": {
                        "prefix": "--minimum_ratio",
                        "position": 50,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/clear_mz_range",
                    "doc": "Removes peaks in this m/z range prior to matching.",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "0.0_0.0",
                    "inputBinding": {
                        "prefix": "--clear_mz_range",
                        "position": 51,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/remove_precursor_peak",
                    "doc": "Remove precursor peaks from tandem mass spectra. 0 = not remove; 1 = remove the peak with precursor charge; 2 = remove the peaks with all charge states.",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--remove_precursor_peak",
                        "position": 52,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Cterm_peptide",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Cterm_peptide",
                        "position": 53,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Nterm_peptide",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Nterm_peptide",
                        "position": 54,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Cterm_protein",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Cterm_protein",
                        "position": 55,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Nterm_protein",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Nterm_protein",
                        "position": 56,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_G_glycine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_G_glycine",
                        "position": 57,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_A_alanine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_A_alanine",
                        "position": 58,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_S_serine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_S_serine",
                        "position": 59,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_P_proline",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_P_proline",
                        "position": 60,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_V_valine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_V_valine",
                        "position": 61,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_T_threonine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_T_threonine",
                        "position": 62,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_C_cysteine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 57.021464,
                    "inputBinding": {
                        "prefix": "--add_C_cysteine",
                        "position": 63,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_L_leucine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_L_leucine",
                        "position": 64,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_I_isoleucine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_I_isoleucine",
                        "position": 65,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_N_asparagine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_N_asparagine",
                        "position": 66,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_D_aspartic_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_D_aspartic_acid",
                        "position": 67,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Q_glutamine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Q_glutamine",
                        "position": 68,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_K_lysine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_K_lysine",
                        "position": 69,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_E_glutamic_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_E_glutamic_acid",
                        "position": 70,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_M_methionine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_M_methionine",
                        "position": 71,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_H_histidine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_H_histidine",
                        "position": 72,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_F_phenylalanine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_F_phenylalanine",
                        "position": 73,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_R_arginine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_R_arginine",
                        "position": 74,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Y_tyrosine",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Y_tyrosine",
                        "position": 75,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_W_tryptophan",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_W_tryptophan",
                        "position": 76,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_B_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_B_user_amino_acid",
                        "position": 77,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_J_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_J_user_amino_acid",
                        "position": 78,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_O_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_O_user_amino_acid",
                        "position": 79,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_U_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_U_user_amino_acid",
                        "position": 80,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_X_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_X_user_amino_acid",
                        "position": 81,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/add_Z_user_amino_acid",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--add_Z_user_amino_acid",
                        "position": 82,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/Xmx",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 8
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/mzML",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/input",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 300,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/diagnostic_intensity_filter",
                    "label": "diagnostic intensity filter",
                    "doc": "nglycan/labile search_mode only]. Minimum relative intensity for SUM of all detected oxonium ions to achieve for spectrum to contain diagnostic fragment evidence. Calculated relative to spectrum base peak. Default (0).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--diagnostic_intensity_filter",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/restrict_deltamass_to",
                    "label": "restrict deltamass to",
                    "doc": "Specify amino acids on which delta masses (mass offsets or search modifications) can occur. Allowed values are single letter codes (e.g. ACD). Default (all).",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "all",
                    "inputBinding": {
                        "prefix": "--restrict_deltamass_to",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/labile_search_mode",
                    "label": "labile search mode",
                    "doc": "type of search (nglycan, labile, or off). Off means non-labile/typical search. Default (off).",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "off",
                    "inputBinding": {
                        "prefix": "--labile_search_mode",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/mass_diff_to_variable_mod",
                    "label": "mass diff to variable mod",
                    "doc": "Put mass diff as a variable modification. 0 for no; 1 for yes and change the original mass diff and the calculated mass accordingly; 2 for yes but do not change the original mass diff. Default (0).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": -1,
                    "inputBinding": {
                        "prefix": "--mass_diff_to_variable_mod",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/intensity_transform",
                    "label": "intensity transform",
                    "doc": "transform peaks intensities with sqrt root. 0=not transform; 1=transform using sqrt root. Default (0).",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--intensity_transform",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/EULA",
                    "label": "Accept End Level User Agreement",
                    "type": "boolean"
                }
            ],
            "outputs": [
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/standard_out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.mzML[0].metadata[\"Plex or dataset name\"]).msfragger.log",
                        "outputEval": "$(inheritMetadata(self, inputs.mzML))"
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/pepxml",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.pepXML",
                        "outputEval": "$(inheritMetadata(self, inputs.mzML))"
                    }
                },
                {
                    "id": "#msfragger.cwl/david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3/mgf",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.mgf",
                        "outputEval": "$(inheritMetadata(self, inputs.mzML))"
                    }
                }
            ],
            "stdout": "$(inputs.mzML[0].metadata[\"Plex or dataset name\"]).msfragger.log",
            "baseCommand": [],
            "arguments": [
                {
                    "prefix": "",
                    "position": 3,
                    "valueFrom": "${if (inputs.EULA) {\n    return \"java -Xmx\" + inputs.Xmx + \"G\"\n    \n} else {\n    return \"Must accept EULA\"\n    \n}}",
                    "separate": false,
                    "shellQuote": false
                },
                {
                    "prefix": "-jar",
                    "position": 3,
                    "valueFrom": "/data/MSFragger-3.2/MSFragger-3.2.jar *.mzML",
                    "shellQuote": false
                }
            ],
            "id": "#msfragger.cwl",
            "null": null,
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcontent_hash": "ac7f11bb5394704ce3187ffe2aa0507e98d5b82111ea362d080114f060c99f875",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1618954817,
            "https://sevenbridges.comid": "david.roberson/build-fragpipe-proteomics-pipeline-tutorial/msfragger/3",
            "https://sevenbridges.comimage_url": null,
            "https://sevenbridges.comlatestRevision": 3,
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1618979548,
            "https://sevenbridges.comproject": "david.roberson/build-fragpipe-proteomics-pipeline-tutorial",
            "https://sevenbridges.comprojectName": "BUILD: FragPipe Proteomics Pipeline Tutorial",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 3,
            "https://sevenbridges.comrevisionNotes": "",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618954817,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/fragpipe-proteomics-pipeline-tutorial.git\nfile: FragPipe_Convert_Identify_PeptideProphet/FragPipe_Convert_Identify_PeptideProphet.cwl.steps/msfragger.cwl\ncommit: bc53527"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618955283,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": "added EULA toggle"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618955396,
                    "https://sevenbridges.comrevision": 2,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1618979548,
                    "https://sevenbridges.comrevision": 3,
                    "https://sevenbridges.comrevisionNotes": ""
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comvalidationErrors": []
        },
        {
            "class": "CommandLineTool",
            "label": "Philosopher PeptideProphet",
            "doc": "```\nPeptide assignment validation\n\nUsage:\n  philosopher peptideprophet [flags]\n\nFlags:\n      --accmass            use accurate mass model binning\n      --clevel int         set Conservative Level in neg_stdev from the neg_mean, low numbers are less conservative, high numbers are more conservative\n      --combine            combine the results from PeptideProphet into a single result file\n      --database string    path to the database\n      --decoy string       semi-supervised mode, protein name prefix to identify decoy entries (default \"rev_\")\n      --decoyprobs         compute possible non-zero probabilities for decoy entries on the last iteration\n      --enzyme string      enzyme used in sample\n      --expectscore        use expectation value as the only contributor to the f-value for modeling\n      --glyc               enable peptide glyco motif model\n  -h, --help               help for peptideprophet\n      --ignorechg string   use comma to separate the charge states to exclude from modeling\n      --masswidth float    model mass width (default 5)\n      --minpeplen int      minimum peptide length not rejected (default 7)\n      --minprob float      report results with minimum probability (default 0.05)\n      --nomass             disable mass model\n      --nonmc              disable NMC missed cleavage model\n      --nonparam           use semi-parametric modeling, must be used in conjunction with --decoy option\n      --nontt              disable NTT enzymatic termini model\n      --output string      output name prefix (default \"interact\")\n      --phospho            enable peptide phospho motif model\n      --ppm                use ppm mass error instead of Daltons for mass modeling```\n\n\n```",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "LoadListingRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "ramMin": 2000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "prvst/philosopher:latest"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.pepXML)",
                        "$(inputs.mzML)",
                        "$(inputs.workspace_in)",
                        {
                            "entryname": "philosopher_peptideprophet.sh",
                            "writable": false,
                            "entry": "tar -xvzf $(inputs.workspace_in.path) -C ./\n\nmv *.mzML *.pepXML *pep.xml $(inputs.workspace_in.metadata[\"Plex or dataset name\"])\n\ncd $(inputs.workspace_in.metadata[\"Plex or dataset name\"])\n\nphilosopher peptideprophet $@\n\ncd ../\n\ntar -cvzf $(inputs.workspace_in.metadata[\"Plex or dataset name\"]).for_filter.tar.gz $(inputs.workspace_in.metadata[\"Plex or dataset name\"])\n\nrm $(inputs.workspace_in.metadata[\"Plex or dataset name\"])/*.mzML \n\ntar -cvzf $(inputs.workspace_in.metadata[\"Plex or dataset name\"]).for_protein.tar.gz $(inputs.workspace_in.metadata[\"Plex or dataset name\"])"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file)) {\n        file['metadata'] = {}\n    }\n    for (var key in metadata) {\n        file['metadata'][key] = metadata[key];\n    }\n    return file\n};\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!o2) {\n        return o1;\n    };\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n        for (var key in commonMetadata) {\n            if (!(key in example)) {\n                delete commonMetadata[key]\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n        if (o1.secondaryFiles) {\n            o1.secondaryFiles = inheritMetadata(o1.secondaryFiles, o2)\n        }\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n            if (o1[i].secondaryFiles) {\n                o1[i].secondaryFiles = inheritMetadata(o1[i].secondaryFiles, o2)\n            }\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/accmass",
                    "doc": "use accurate mass model binning",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--accmass",
                        "position": 0,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/combine",
                    "doc": "combine the results from PeptideProphet into a single result file",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--combine",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/--database",
                    "doc": "path to the database",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--database",
                        "position": 2,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/decoy",
                    "doc": "semi-supervised mode, protein name prefix to identify decoy entries (default \"rev_\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "rev_",
                    "inputBinding": {
                        "prefix": "--decoy",
                        "position": 3,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/decoyprobs",
                    "doc": "compute possible non-zero probabilities for decoy entries on the last iteration",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--decoyprobs",
                        "position": 4,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/enzyme",
                    "doc": "enzyme used in sample",
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "trypsin",
                    "inputBinding": {
                        "prefix": "--enzyme",
                        "position": 5,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/expectscore",
                    "doc": "use expectation value as the only contributor to the f-value for modeling",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--expectscore",
                        "position": 6,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/masswidth",
                    "doc": "model mass width (default 5)",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 5,
                    "inputBinding": {
                        "prefix": "--masswidth",
                        "position": 7,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/minpeplen",
                    "doc": "minimum peptide length not rejected (default 7)",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 7,
                    "inputBinding": {
                        "prefix": "--minpeplen",
                        "position": 8,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/minprob",
                    "doc": "report results with minimum probability (default 0.05)",
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.05,
                    "inputBinding": {
                        "prefix": "--minprob",
                        "position": 9,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/nonparam",
                    "doc": "use semi-parametric modeling, must be used in conjunction with --decoy option",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--nonparam",
                        "position": 10,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/nontt",
                    "doc": "disable NTT enzymatic termini model",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--nontt",
                        "position": 11,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/ppm",
                    "doc": "use ppm mass error instead of Daltons for mass modeling",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--ppm",
                        "position": 12,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/pepXML",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/mzML",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/workspace_in",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/peptide_prophet_log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.pepXML[0].metadata[\"Plex or dataset name\"]).peptide_prophet.log",
                        "outputEval": "$(inheritMetadata(self, inputs.pepXML))"
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/output_xml",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*pep.xml",
                        "outputEval": "$(inheritMetadata(self, inputs.pepXML))"
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/peptide_prophet_folder_archive",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.for_protein.tar.gz\n\n",
                        "outputEval": "$(inheritMetadata(self, inputs.pepXML))"
                    }
                },
                {
                    "id": "#peptide_prophet.cwl/david.roberson/pdc-webinar-dev/peptide-prophet/6/peptide_archive_with_mzml",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*for_filter.tar.gz",
                        "outputEval": "$(inheritMetadata(self, inputs.pepXML))"
                    }
                }
            ],
            "baseCommand": [
                "bash philosopher_peptideprophet.sh"
            ],
            "arguments": [
                {
                    "prefix": "",
                    "position": 90,
                    "valueFrom": "*.pepXML",
                    "shellQuote": false
                },
                {
                    "prefix": "",
                    "position": 91,
                    "valueFrom": "> $(inputs.workspace_in.metadata[\"Plex or dataset name\"]).peptide_prophet.log",
                    "shellQuote": false
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "*.sh"
                },
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "*.log"
                }
            ],
            "id": "#peptide_prophet.cwl",
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcategories": [
                "Proteomics"
            ],
            "https://sevenbridges.comcontent_hash": "a10eb2794a4421cb1aec28abd7ceec09963fe078734a55c478d1e091662dcd3b0",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1616618434,
            "https://sevenbridges.comid": "david.roberson/pdc-webinar-dev/peptide-prophet/6",
            "https://sevenbridges.comimage_url": null,
            "https://sevenbridges.comlatestRevision": 6,
            "https://sevenbridges.comlinks": [
                {
                    "id": "#philosopher",
                    "label": "Github Project"
                }
            ],
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1616681184,
            "https://sevenbridges.comproject": "david.roberson/pdc-webinar-dev",
            "https://sevenbridges.comprojectName": "PDC Webinar Dev",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 6,
            "https://sevenbridges.comrevisionNotes": "",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616618434,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/shotgun_proteomics.git\nfile: tools/peptide-prophet/peptide_prophet.cwl\ncommit: 1eb0cff"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616623591,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616629192,
                    "https://sevenbridges.comrevision": 2,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616635332,
                    "https://sevenbridges.comrevision": 3,
                    "https://sevenbridges.comrevisionNotes": "better glob"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616677096,
                    "https://sevenbridges.comrevision": 4,
                    "https://sevenbridges.comrevisionNotes": "added archive in"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616677216,
                    "https://sevenbridges.comrevision": 5,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616681184,
                    "https://sevenbridges.comrevision": 6,
                    "https://sevenbridges.comrevisionNotes": ""
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comtoolAuthor": "Felipe da Veiga Leprevost",
            "https://sevenbridges.comtoolkitVersion": "Philosopher",
            "https://sevenbridges.comvalidationErrors": [],
            "https://sevenbridges.comwrapperAuthor": "Felipe da Veiga Leprevost; David Roberson"
        },
        {
            "class": "CommandLineTool",
            "label": "Philosopher Workspace",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "LoadListingRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "ramMin": 100
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "prvst/philosopher:3.2.3"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.pepXML)",
                        {
                            "entryname": "philosopher_workspace.sh",
                            "writable": false,
                            "entry": "\nmkdir $(inputs.meta_data_files[0].metadata[\"Plex or dataset name\"])\n\ncd $(inputs.meta_data_files[0].metadata[\"Plex or dataset name\"])\n\nphilosopher workspace $@\n\ncd ../\n\ntar -cvzf $(inputs.meta_data_files[0].metadata[\"Plex or dataset name\"]).tar.gz $(inputs.meta_data_files[0].metadata[\"Plex or dataset name\"])"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "\nvar setMetadata = function(file, metadata) {\n    if (!('metadata' in file)) {\n        file['metadata'] = {}\n    }\n    for (var key in metadata) {\n        file['metadata'][key] = metadata[key];\n    }\n    return file\n};\nvar inheritMetadata = function(o1, o2) {\n    var commonMetadata = {};\n    if (!o2) {\n        return o1;\n    };\n    if (!Array.isArray(o2)) {\n        o2 = [o2]\n    }\n    for (var i = 0; i < o2.length; i++) {\n        var example = o2[i]['metadata'];\n        for (var key in example) {\n            if (i == 0)\n                commonMetadata[key] = example[key];\n            else {\n                if (!(commonMetadata[key] == example[key])) {\n                    delete commonMetadata[key]\n                }\n            }\n        }\n        for (var key in commonMetadata) {\n            if (!(key in example)) {\n                delete commonMetadata[key]\n            }\n        }\n    }\n    if (!Array.isArray(o1)) {\n        o1 = setMetadata(o1, commonMetadata)\n        if (o1.secondaryFiles) {\n            o1.secondaryFiles = inheritMetadata(o1.secondaryFiles, o2)\n        }\n    } else {\n        for (var i = 0; i < o1.length; i++) {\n            o1[i] = setMetadata(o1[i], commonMetadata)\n            if (o1[i].secondaryFiles) {\n                o1[i].secondaryFiles = inheritMetadata(o1[i].secondaryFiles, o2)\n            }\n        }\n    }\n    return o1;\n};"
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/init",
                    "doc": "Initialize the workspace",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": null,
                    "inputBinding": {
                        "prefix": "--init",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/analytics",
                    "doc": "reports when a workspace is created for usage estimation (default true)",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--analytics",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/backup",
                    "doc": "create a backup of the experiment meta data",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--backup",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/clean",
                    "doc": "remove the workspace and all meta data. Experimental file are kept intact",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--clean",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/nocheck",
                    "doc": "do not check for new versions",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--nocheck",
                        "position": 1,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/meta_data_files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 0,
                        "valueFrom": "./$(self[0].metadata[\"Plex or dataset name\"])",
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#workspace.cwl/david.roberson/pdc-webinar-dev/workspace/5/workspace",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.tar.gz",
                        "outputEval": "$(inheritMetadata(self, inputs.meta_data_files))"
                    }
                }
            ],
            "stdout": "std.out",
            "baseCommand": [
                "bash philosopher_workspace.sh"
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "*.sh"
                },
                {
                    "class": "https://sevenbridges.comSaveLogs",
                    "value": "std.out"
                }
            ],
            "id": "#workspace.cwl",
            "https://sevenbridges.comappVersion": [
                "v1.1"
            ],
            "https://sevenbridges.comcontent_hash": "a04c6999346eef832c6aee72c9f54d427ac8f57881e6d5731fd842444398ea973",
            "https://sevenbridges.comcontributors": [
                "david.roberson"
            ],
            "https://sevenbridges.comcreatedBy": "david.roberson",
            "https://sevenbridges.comcreatedOn": 1616629639,
            "https://sevenbridges.comid": "david.roberson/pdc-webinar-dev/workspace/5",
            "https://sevenbridges.comimage_url": null,
            "https://sevenbridges.comlatestRevision": 5,
            "https://sevenbridges.commodifiedBy": "david.roberson",
            "https://sevenbridges.commodifiedOn": 1617114475,
            "https://sevenbridges.comproject": "david.roberson/pdc-webinar-dev",
            "https://sevenbridges.comprojectName": "PDC Webinar Dev",
            "https://sevenbridges.compublisher": "sbg",
            "https://sevenbridges.comrevision": 5,
            "https://sevenbridges.comrevisionNotes": "",
            "https://sevenbridges.comrevisionsInfo": [
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616629639,
                    "https://sevenbridges.comrevision": 0,
                    "https://sevenbridges.comrevisionNotes": "Uploaded using sbpack v2020.10.05. \nSource: \nrepo: https://github.com/davidroberson/shotgun_proteomics.git\nfile: tools/workspace/workspace.cwl\ncommit: 31fdf12"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616629985,
                    "https://sevenbridges.comrevision": 1,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616674457,
                    "https://sevenbridges.comrevision": 2,
                    "https://sevenbridges.comrevisionNotes": "added tar"
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616674508,
                    "https://sevenbridges.comrevision": 3,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1616677891,
                    "https://sevenbridges.comrevision": 4,
                    "https://sevenbridges.comrevisionNotes": ""
                },
                {
                    "https://sevenbridges.commodifiedBy": "david.roberson",
                    "https://sevenbridges.commodifiedOn": 1617114475,
                    "https://sevenbridges.comrevision": 5,
                    "https://sevenbridges.comrevisionNotes": ""
                }
            ],
            "https://sevenbridges.comsbgMaintained": false,
            "https://sevenbridges.comvalidationErrors": []
        }
    ],
    "cwlVersion": "v1.1",
    "$namespaces": {
        "sbg": "https://sevenbridges.com"
    }
}
